apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "persons.fullname" . }}
  labels:
    app: {{ include "persons.name" . }}
    release: {{ .Release.Name }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      app: {{ include "persons.name" . }}
      release: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app: {{ include "persons.name" . }}
        release: {{ .Release.Name }}

    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      initContainers:
        - name: db-check-container
          image: arey/mysql-client:latest
          command: [ 'sh','/scripts/db-check.sh' ]
          env:
            - name: PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-db-secret
                  key: password
            - name: USERNAME
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-db-secret
                  key: username
          volumeMounts:
            - name: db-check-config-map
              mountPath: /scripts
      containers:
        - name: {{ .Chart.Name }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: spring.datasource.url
              value: "jdbc:mysql://{{ .Release.Name }}-mysql/${database.name}?allowPublicKeyRetrieval=true"
            - name: spring.datasource.password
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-db-secret
                  key: password
            - name: spring.datasource.username
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-db-secret
                  key: username
            - name: database.name
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-db-secret
                  key: database
          ports:
            - name: http
              containerPort: 8090
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /actuator/health
              port: http
            initialDelaySeconds: 60
            failureThreshold: 5
            periodSeconds: 10
          readinessProbe:
            httpGet:
              path: /actuator/health
              port: http
            initialDelaySeconds: 60
            failureThreshold: 5
            periodSeconds: 10
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      volumes:
        - name: db-check-config-map
          configMap:
            name: {{ .Release.Name }}-db-check-config-map
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
